within ;
package cv3
  model bb

    constant Real g = 10;
    //  parameter Real m = 1;
    Real s(start = 1);
    Real v;
  discrete Real a(start = -g);
  parameter Real c = 0.9 "utlum odrazu";
  equation
    v = der(s);
    a = der(v);
    when s < 0 then
      // v -> -v*c
      reinit(v, -v * c);
    end when;
    when s < (-1e-3) then
      reinit(s, 0);
      reinit(v, 0);
      //    a = 0;
    end when;
    //  assert(s > (-1e-3), "Propadli jsme podlahou! Koncim.");
  end bb;

  model balon

    pqcon pqcon1 annotation(Placement(visible = true, transformation(origin = {4, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {4, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Real V;
  parameter Real iv = 1;
    Modelica.Blocks.Interfaces.RealInput c annotation (Placement(transformation(
            extent={{-96,58},{-56,98}}), iconTransformation(extent={{-96,58},{-56,
              98}})));
  initial equation
    V = iv;
  equation
    pqcon1.p = V * c;
    der(V) = pqcon1.q;
    annotation(Icon(graphics={  Ellipse(origin = {1, 1}, extent = {{-87, 77}, {87, -77}}, endAngle = 360)}), Diagram);
  end balon;

  connector pqcon
    Real p;
    flow Real q;
    annotation(Icon(graphics={  Rectangle(origin = {3, -4}, fillColor = {46, 79, 59},
              fillPattern =                                                                         FillPattern.Solid, extent = {{-89, 92}, {89, -92}})}), Diagram);
  end pqcon;

  model odpor
    pqcon pqcon1 annotation(Placement(visible = true, transformation(origin = {-92, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-92, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  pqcon pqcon2 annotation(Placement(visible = true, transformation(origin = {88, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {88, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  parameter Real R = 1;
  parameter Real L = 0;
  equation
    if L == 0 then
      pqcon1.p - pqcon2.p = R * pqcon1.q;
    else
      pqcon1.p - pqcon2.p = R * pqcon1.q + L * der(pqcon1.q);
    end if;
    pqcon1.q + pqcon2.q = 0;
    annotation(Icon(graphics={  Rectangle(origin = {-1, 0}, extent = {{-83, 22}, {83, -22}})}), Diagram(graphics={  Rectangle(origin = {2, 11}, extent = {{-92, 41}, {92, -41}})}));
  end odpor;

  model chlopen
    Real s;
    Real dp;
    Real q;
    Boolean open;
    parameter Real rOpen = 1e-3;
    parameter Real gClose = 1e-3;
  pqcon pqcon1 annotation(Placement(visible = true, transformation(origin = {-88, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-88, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  pqcon pqcon2 annotation(Placement(visible = true, transformation(origin = {86, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {86, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation
    open = s > 0;
    if open then
      dp = s*rOpen;
      s = q;
    else
      dp = s;
      q = s*gClose;
    end if;
    pqcon1.q + pqcon2.q = 0;
  pqcon1.q = q;
    pqcon1.p - pqcon2.p = dp;
    annotation(Icon(graphics={           Polygon(origin={2.00001,12.0936},     points = {{-68, 75.9064}, {-64, -84.0936}, {44, -6.09355}, {50, -82.0936}, {68, -82.0936}, {64, 83.9064}, {34, 81.9064}, {40, 5.90645}, {-68, 75.9064}})}));
  end chlopen;

  model p_src
    cv3.pqcon pqcon1 annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {2, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  parameter Real p;
  equation
    pqcon1.p = p;
    annotation(Icon(graphics={  Polygon(origin = {-1.02352, -11.9992}, points = {{-76.9765, 77.9992}, {59.0235, 77.9992}, {91.0235, -8.00083}, {55.0235, -78.0008}, {-48.9765, -72.0008}, {-90.9765, -0.000830029}, {-76.9765, 77.9992}})}), Diagram);
  end p_src;

  model system1

    p_src p_src1(p=1)
      annotation (Placement(transformation(extent={{-98,0},{-78,20}})));
    odpor odpor1
      annotation (Placement(transformation(extent={{-66,0},{-46,20}})));
    chlopen chlopen1
      annotation (Placement(transformation(extent={{-32,2},{-12,22}})));
    balon balon1 annotation (Placement(transformation(extent={{6,14},{26,34}})));
    chlopen chlopen2
      annotation (Placement(transformation(extent={{24,-4},{44,16}})));
    p_src p_src2(p=10)
      annotation (Placement(transformation(extent={{80,-2},{100,18}})));
    Modelica.Blocks.Sources.Sine sine(
      amplitude=1,
      freqHz=1,
      offset=1.1)
      annotation (Placement(transformation(extent={{-50,36},{-30,56}})));
    odpor odpor2
      annotation (Placement(transformation(extent={{54,-4},{74,16}})));
  equation
    connect(chlopen2.pqcon1, balon1.pqcon1) annotation (Line(points={{25.2,5.8},
            {16.4,5.8},{16.4,16}}, color={0,0,0}));
    connect(chlopen1.pqcon2, chlopen2.pqcon1) annotation (Line(points={{-13.4,
            12.2},{4,12.2},{4,5.8},{25.2,5.8}}, color={0,0,0}));
    connect(chlopen1.pqcon1, odpor1.pqcon2) annotation (Line(points={{-30.8,
            11.8},{-39.4,11.8},{-39.4,10.2},{-47.2,10.2}}, color={0,0,0}));
    connect(odpor1.pqcon1, p_src1.pqcon1) annotation (Line(points={{-65.2,9.8},
            {-87.8,9.8},{-87.8,10}}, color={0,0,0}));
    connect(sine.y, balon1.c) annotation (Line(points={{-29,46},{-12,46},{-12,
            34},{-12,31.8},{8.4,31.8}}, color={0,0,127}));
    connect(chlopen2.pqcon2, odpor2.pqcon1) annotation (Line(points={{42.6,6.2},
            {54.3,6.2},{54.3,5.8},{54.8,5.8}}, color={0,0,0}));
    connect(odpor2.pqcon2, p_src2.pqcon1) annotation (Line(points={{72.8,6.2},{
            90.2,6.2},{90.2,8}}, color={0,0,0}));
    annotation (Diagram(coordinateSystem(preserveAspectRatio=false, extent={{
              -100,-100},{100,100}})));
  end system1;

  model unstableSys
    balon balon1(iv=1)
      annotation (Placement(transformation(extent={{-92,48},{-72,68}})));
    balon balon2(iv=1e-3)
      annotation (Placement(transformation(extent={{66,62},{86,82}})));
    odpor odpor1(R=10, L=100)
      annotation (Placement(transformation(extent={{-62,36},{-42,56}})));
    chlopen chlopen1(rOpen=0, gClose=0)
      annotation (Placement(transformation(extent={{-14,36},{6,56}})));
    Modelica.Blocks.Sources.Constant const(k=1)
      annotation (Placement(transformation(extent={{-74,108},{-54,128}})));
    odpor odpor2(R=10, L=100)
      annotation (Placement(transformation(extent={{26,36},{46,56}})));
    balon balon3(iv=1e-9)
      annotation (Placement(transformation(extent={{-76,-8},{-56,12}})));
    odpor odpor3(R=1e9)
      annotation (Placement(transformation(extent={{-50,-16},{-30,4}})));
    Modelica.Blocks.Sources.Constant const1(k=1e9)
      annotation (Placement(transformation(extent={{-94,10},{-74,30}})));
    balon balon4(iv=1e-9)
      annotation (Placement(transformation(extent={{-4,62},{16,82}})));
    odpor odpor4(R=1e9)
      annotation (Placement(transformation(extent={{22,54},{42,74}})));
    Modelica.Blocks.Sources.Constant const2(k=1e9)
      annotation (Placement(transformation(extent={{-22,86},{-2,106}})));
    balon balon5(iv=1)
      annotation (Placement(transformation(extent={{-76,-104},{-56,-84}})));
    balon balon6(iv=1e-3)
      annotation (Placement(transformation(extent={{82,-90},{102,-70}})));
    odpor odpor5(R=10, L=100)
      annotation (Placement(transformation(extent={{-46,-116},{-26,-96}})));
    chlopen chlopen2(rOpen=1e-3, gClose=1e-3)
      annotation (Placement(transformation(extent={{2,-116},{22,-96}})));
    odpor odpor6(R=10, L=100)
      annotation (Placement(transformation(extent={{42,-116},{62,-96}})));
    Modelica.Blocks.Sources.Constant const3(
                                           k=1)
      annotation (Placement(transformation(extent={{-102,-72},{-82,-52}})));
  equation
    connect(balon1.pqcon1, odpor1.pqcon1) annotation (Line(
        points={{-81.6,50},{-80,50},{-80,45.8},{-61.2,45.8}},
        color={0,0,0},
        smooth=Smooth.None));
    connect(odpor1.pqcon2, chlopen1.pqcon1) annotation (Line(
        points={{-43.2,46.2},{-27.6,46.2},{-27.6,45.8},{-12.8,45.8}},
        color={0,0,0},
        smooth=Smooth.None));
    connect(const.y, balon1.c) annotation (Line(
        points={{-53,118},{-46,118},{-46,70},{-89.6,70},{-89.6,65.8}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(const.y, balon2.c) annotation (Line(
        points={{-53,118},{68.4,118},{68.4,79.8}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(chlopen1.pqcon2, odpor2.pqcon1) annotation (Line(
        points={{4.6,46.2},{15.3,46.2},{15.3,45.8},{26.8,45.8}},
        color={0,0,0},
        smooth=Smooth.None));
    connect(odpor2.pqcon2, balon2.pqcon1) annotation (Line(
        points={{44.8,46.2},{76.4,46.2},{76.4,64}},
        color={0,0,0},
        smooth=Smooth.None));
    connect(odpor3.pqcon2, chlopen1.pqcon1) annotation (Line(
        points={{-31.2,-5.8},{-18,-5.8},{-18,45.8},{-12.8,45.8}},
        color={0,0,0},
        smooth=Smooth.None));
    connect(odpor3.pqcon1, balon3.pqcon1) annotation (Line(
        points={{-49.2,-6.2},{-64.6,-6.2},{-64.6,-6},{-65.6,-6}},
        color={0,0,0},
        smooth=Smooth.None));
    connect(const1.y, balon3.c) annotation (Line(
        points={{-73,20},{-72,20},{-72,9.8},{-73.6,9.8}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(odpor4.pqcon1, balon4.pqcon1) annotation (Line(
        points={{22.8,63.8},{7.4,63.8},{7.4,64},{6.4,64}},
        color={0,0,0},
        smooth=Smooth.None));
    connect(const2.y, balon4.c) annotation (Line(
        points={{-1,96},{0,96},{0,79.8},{-1.6,79.8}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(odpor4.pqcon2, chlopen1.pqcon2) annotation (Line(
        points={{40.8,64.2},{48,64.2},{48,54},{22,54},{22,46.2},{4.6,46.2}},
        color={0,0,0},
        smooth=Smooth.None));
    connect(balon5.pqcon1,odpor5. pqcon1) annotation (Line(
        points={{-65.6,-102},{-64,-102},{-64,-106.2},{-45.2,-106.2}},
        color={0,0,0},
        smooth=Smooth.None));
    connect(odpor5.pqcon2,chlopen2. pqcon1) annotation (Line(
        points={{-27.2,-105.8},{-11.6,-105.8},{-11.6,-106.2},{3.2,-106.2}},
        color={0,0,0},
        smooth=Smooth.None));
    connect(const3.y, balon5.c) annotation (Line(
        points={{-81,-62},{-30,-62},{-30,-82},{-73.6,-82},{-73.6,-86.2}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(chlopen2.pqcon2,odpor6. pqcon1) annotation (Line(
        points={{20.6,-105.8},{31.3,-105.8},{31.3,-106.2},{42.8,-106.2}},
        color={0,0,0},
        smooth=Smooth.None));
    connect(odpor6.pqcon2,balon6. pqcon1) annotation (Line(
        points={{60.8,-105.8},{92.4,-105.8},{92.4,-88}},
        color={0,0,0},
        smooth=Smooth.None));
    connect(const3.y, balon6.c) annotation (Line(
        points={{-81,-62},{2,-62},{2,-72.2},{84.4,-72.2}},
        color={0,0,127},
        smooth=Smooth.None));
    annotation (
      Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{
              100,100}}), graphics),
      experiment(StopTime=1000),
      __Dymola_experimentSetupOutput);
  end unstableSys;
  annotation(Icon, Diagram,
    uses(Modelica(version="3.2.1")));
end cv3;
